/* VAARALLISTA!  ... eli HAUSKAA (tiettyyn pisteeseen asti..). 
 *
 * Ei saa kokeilla yhteiskäyttökoneilla! Kotikoneella täysin omalla
 * vastuulla.
 *
 * Tässä esimerkissä luodaan lapsiprosesseja niin kauan kuin
 * pystyy. Lisäksi lapsiprosessit käyttävät prosessoriaikaa.
 * Vuorontaja joutuu siis aika pian aika koville.
 *
 */
#include<stdio.h>
#include<stdlib.h>

#include "turvavyo.h"

int main(int argc, char *argv[]){
  int pid;
  int n = 0;
  char pikku_jononen[4096];
  int i;

  lopeta_jos_ei_turvallinen_kone();

  for(;;){
    sleep(1); /*Pidetään sekunnin tauko aina ennen seuraavan prosessin
                luontia; ehdit tarkkailla prosessorin resurssien
                käytön muuttumista vaikka top-ohjelmalla toisessa
                terminaali-ikkunassa*/

    switch (pid=fork()) {
    case 0: 
      /* Ollaan työteliäs pikku lapsiprosessi ja rotatoidaan
       * merkkijonoa.  Voi miettiä, olisiko helppo esim. tehdä
       * tällainen ohjelmointivirheenä, vaikka olisi ollut tarkoitus
       * rotatoida jono vain kerran eikä ikuisesti... luottaisi
       * siihen, että lapsiprosessi suorittaa jonkun operaation
       * tausta-ajona ja loppuu sitten, koodasinhan mä siihen exit(0)
       * -komennon heti luupin perään... Mutta hupsista, jos operaatio
       * on monimutkainen ja ohjelmointivirhe tulee ilmi vain
       * keskimäärin joka tuhannella kerralla. "Hyvin toimii testissä;
       * toimitetaan asiakkaalle tuotantökäyttöön heti huomenna..."
       */
      for (i=0; i>=0; i++){
        pikku_jononen[i % 4096] = pikku_jononen[(i+1) % 4096];
      }
      exit(0);
    case -1: 
      perror("fork() failed");
      break;
    default:
      printf("Tein lapsiprosessin, jonka PID on %d (yht. %d kpl) \n", pid, ++n);
    } 
  }
  return 0;
}
